use Wx qw/wxFONTFAMILY_SWISS wxFONTSTYLE_NORMAL wxFONTWEIGHT_NORMAL wxFONTWEIGHT_BOLD  wxGREEN /;
use Wx::Calendar;
use Wx::DateTime;
use strict;

# Custom source
use Uploader::GUI::wxChoiceFilteredPanel;

use Wx qw( wxDefaultSize wxDefaultPosition wxNullAnimation wxNullFont wxBLACK );
use Wx qw( wxID_OK wxID_APPLY wxID_SAVE wxID_SAVEAS wxID_CANCEL wxID_YES wxID_NO wxID_EXIT wxID_ABOUT wxID_HELP );
use Wx qw( wxVERTICAL wxHORIZONTAL wxALL wxLEFT wxRIGHT wxTOP wxBOTTOM wxCENTRE wxGROW wxEXPAND);
use Wx qw( wxALIGN_RIGHT wxALIGN_BOTTOM wxALIGN_CENTER wxALIGN_CENTER_VERTICAL wxALIGN_CENTER_HORIZONTAL );
use Wx qw( wxTR_HAS_BUTTONS wxTR_LINES_AT_ROOT wxSUNKEN_BORDER wxLI_HORIZONTAL wxTE_MULTILINE );
use Wx qw( wxDP_DROPDOWN );

# Bitmap functions

use Wx qw( wxNullBitmap wxBITMAP_TYPE_PNG );

# Window functions

use vars qw($PHOTO_PROPERTIES_NB); $PHOTO_PROPERTIES_NB = 10000;
use vars qw($PHOTO_PROPERTIES_CATEGORIES); $PHOTO_PROPERTIES_CATEGORIES = 10001;
use vars qw($ID_LINE); $ID_LINE = 10002;
use vars qw($PHOTO_PROPERTIES_UPLOAD); $PHOTO_PROPERTIES_UPLOAD = 10003;

sub PhotoPropertiesCategoriesTags {
    my( $parent ) = @_;
    my( $topsizer ) = Wx::BoxSizer->new( wxVERTICAL );
    
    # defines minimum size
    my( $item2 ) = Wx::Notebook->new( $parent, $main::PHOTO_PROPERTIES_NB, wxDefaultPosition, [450,160], 0 );
    my( $item1 ) = $item2;
    if( Wx->VERSION < 0.21 ) {
        $item1 = Wx::NotebookSizer->new( $item2 );
    }
    
    # the notebook has adaptive size : stretch factor 2, wxEXPAND
    $topsizer->Add( $item1, 2, wxEXPAND|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    my( $item3 ) = Wx::TreeCtrl->new( $parent, $main::PHOTO_PROPERTIES_CATEGORIES, wxDefaultPosition, [450,160], wxTR_HAS_BUTTONS|wxTR_LINES_AT_ROOT );
    # the notebook has adaptive size : stretch factor 1, wxEXPAND
    $topsizer->AddWindow( $item3, 1, wxGROW|wxALL, 5 );

    my( $item4 ) = Wx::StaticLine->new( $parent, $main::ID_LINE, wxDefaultPosition, [20,-1], wxLI_HORIZONTAL );
    $topsizer->AddWindow( $item4, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    my( $item5 ) = Wx::Button->new( $parent, $main::PHOTO_PROPERTIES_UPLOAD, "", wxDefaultPosition, [-1,40], 0 );
    my $btfont = Wx::Font->new(16, wxFONTFAMILY_SWISS, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_BOLD );
    $item5->SetFont($btfont);
#    $item5->SetForegroundColour( Wx::wxGREEN );
    $item5->SetForegroundColour( Wx::Colour->new(255, 51, 99) );
    $topsizer->AddWindow( $item5, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    $parent->SetSizer( $topsizer );
    $topsizer->SetSizeHints( $parent );

    $topsizer;
}

use vars qw($TAGS); $TAGS = 10004;
use vars qw($PHOTO_PROPERTIES_TAG); $PHOTO_PROPERTIES_TAG = 10005;

sub photo_properties_tags {
    my( $parent, $tags ) = @_;
    my( $topsizer ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::StaticText->new( $parent, $main::TAGS, "text", wxDefaultPosition, wxDefaultSize, 0 );
    $topsizer->AddWindow( $item1, 0, wxALIGN_CENTER_VERTICAL|wxBOTTOM, 5 );

    $tags->{parentwnd}=$parent;
    my( $panel ) = Uploader::GUI::wxChoiceFilteredPanel->new($tags);
    # the panel has adaptive size : stretch factor 1, wxEXPAND
    $topsizer->AddWindow( $panel, 1, wxEXPAND|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    $parent->SetSizer( $topsizer );
    $topsizer->SetSizeHints( $parent );
    
    $topsizer;
}

use vars qw($CAPTION); $CAPTION = 10006;
use vars qw($PHOTO_PROPERTIES_CAPTION); $PHOTO_PROPERTIES_CAPTION = 10007;
use vars qw($AUTHOR); $AUTHOR = 10008;
use vars qw($PHOTO_PROPERTIES_AUTHOR); $PHOTO_PROPERTIES_AUTHOR = 10009;
use vars qw($COMMENT); $COMMENT = 10010;
use vars qw($PHOTO_PROPERTIES_COMMENT); $PHOTO_PROPERTIES_COMMENT = 10011;
use vars qw($CREATE_DATE); $CREATE_DATE = 10012;
use vars qw($PHOTO_PROPERTIES_CREATE_DATE); $PHOTO_PROPERTIES_CREATE_DATE = 10013;
use vars qw($PRIVACY_LEVEL); $PRIVACY_LEVEL = 10014;
use vars qw($PHOTO_PROPERTIES_PRIVACY_LEVEL); $PHOTO_PROPERTIES_PRIVACY_LEVEL = 10015;

sub photo_properties_caption_comments {
    my( $parent ) = @_;
    my( $topsizer ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item2 ) = Wx::StaticText->new( $parent, $main::CAPTION, "text", wxDefaultPosition, wxDefaultSize, 0 );
    $item1->AddWindow( $item2, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    my( $item3 ) = Wx::TextCtrl->new( $parent, $main::PHOTO_PROPERTIES_CAPTION, "", wxDefaultPosition, [-1,-1], 0 );
    $item1->AddWindow( $item3, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    $topsizer->Add( $item1, 0, wxEXPAND, 5 );

    my( $item4 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item5 ) = Wx::StaticText->new( $parent, $main::AUTHOR, "text", wxDefaultPosition, wxDefaultSize, 0 );
    $item4->AddWindow( $item5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    my( $item6 ) = Wx::TextCtrl->new( $parent, $main::PHOTO_PROPERTIES_AUTHOR, "", wxDefaultPosition, [-1,-1], 0 );
    $item4->AddWindow( $item6, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    my( $item7 ) = Wx::StaticText->new( $parent, $main::COMMENT, "text", wxDefaultPosition, wxDefaultSize, 0 );
    $item4->AddWindow( $item7, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    # adaptive size : stretch factor 1
    # the textctrl has a variable line number
    my( $item8 ) = Wx::TextCtrl->new( $parent, $main::PHOTO_PROPERTIES_COMMENT, "", wxDefaultPosition, [-1,-1], wxTE_MULTILINE );
    $item4->AddWindow( $item8, 1, wxEXPAND|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    my( $item9 ) = Wx::StaticText->new( $parent, $main::CREATE_DATE, "text", wxDefaultPosition, wxDefaultSize, 0 );
    $item4->AddWindow( $item9, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    my( $item10 ) = Wx::DatePickerCtrl->new( $parent, $main::PHOTO_PROPERTIES_CREATE_DATE, Wx::DateTime->new(), wxDefaultPosition, [200,-1], wxDP_DROPDOWN );
    $item4->AddWindow( $item10, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );
    # adaptive size : stretch factor 3
    $topsizer->Add( $item4, 3, wxEXPAND, 5 );

    my( $item11 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item12 ) = Wx::StaticText->new( $parent, $main::PRIVACY_LEVEL, "text", wxDefaultPosition, wxDefaultSize, 0 );
    $item11->AddWindow( $item12, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    my( $item13 ) = Wx::Choice->new( $parent, $main::PHOTO_PROPERTIES_PRIVACY_LEVEL, wxDefaultPosition, [-1,-1], [], 0 );
    $item11->AddWindow( $item13, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    # adaptive size : stretch factor 1
    $topsizer->Add( $item11, 1, wxEXPAND, 5 );

    $parent->SetSizer( $topsizer );
    $topsizer->SetSizeHints( $parent );
    
    $topsizer;
}

use Wx qw( wxITEM_NORMAL wxITEM_RADIO wxITEM_CHECK );

